# type: ignore
# generated by datamodel-codegen:
#   filename:  https://raw.githubusercontent.com/VNG-Realisatie/Haal-Centraal-BRP-bevragen/master/specificatie/genereervariant/openapi.yaml
#   timestamp: 2022-02-07T06:47:51+00:00

from __future__ import annotations

from datetime import date
from enum import Enum
from pydantic import AnyUrl, BaseModel, Field, conint, constr
from typing import List, Optional


class Reisdocumentnummer(BaseModel):
    __root__: str = Field(
        ...,
        description=("Het nummer van het verstrekte Nederlandse reisdocument.\n"),
        example="546376728",
    )


class AanduidingBijzonderNederlanderschapEnum(Enum):
    """
        Geeft aan dat de persoon behandeld wordt als Nederlander, of dat door de rechter is vastgesteld dat de persoon niet de Nederlandse nationaliteit bezit
    * `behandeld_als_nederlander` - B
    * `vastgesteld_niet_nederlander` - V

    """

    behandeld_als_nederlander = "behandeld_als_nederlander"
    vastgesteld_niet_nederlander = "vastgesteld_niet_nederlander"


class AanduidingBijHuisnummerEnum(Enum):
    """
        De aanduiding die wordt gebruikt voor adressen die geen straatnaam en huisnummeraanduidingen hebben
    * `tegenover` - to
    * `bij` - by

    """

    tegenover = "tegenover"
    bij = "bij"


class GeslachtEnum(Enum):
    """
        Geeft aan dat de persoon een man of vrouw is, of dat het geslacht (nog) onbekend is
    * `man` - M
    * `vrouw` - V
    * `onbekend` - O

    """

    man = "man"
    vrouw = "vrouw"
    onbekend = "onbekend"


class IndicatieGezagMinderjarigeEnum(Enum):
    """
        Geeft aan wie het gezag heeft over de minderjarige persoon.
    * `ouder1` - 1
    * `ouder2` - 2
    * `derden` - D
    * `ouder1_en_derde` - 1D
    * `ouder2_en_derde` - 2D
    * `ouder1_en_ouder2` - 12

    """

    ouder1 = "ouder1"
    ouder2 = "ouder2"
    derden = "derden"
    ouder1_en_derde = "ouder1_en_derde"
    ouder2_en_derde = "ouder2_en_derde"
    ouder1_en_ouder2 = "ouder1_en_ouder2"


class NaamgebruikEnum(Enum):
    """
        De manier waarop de geslachtsnaam van persoon en partner van persoon moet worden verwerkt in de manier waarop persoon wil worden aangesproken
    * `eigen` - E - gebruik alleen de eigen naam
    * `eigen_partner` - N - gebruik de eigen naam voor de partnernaam
    * `partner` - P gebruik alleen de partnernaam
    * `partner_eigen` - V - gebruik de partnernaam voor de eigen naam.


    De aanduiding naamgebruik is verwerkt in Aanhef, Aanschrijfwijze en gebruikInLopendeTekst."

    """

    eigen = "eigen"
    eigen_partner = "eigen_partner"
    partner = "partner"
    partner_eigen = "partner_eigen"


class OuderAanduidingEnum(Enum):
    """
        Geeft aan om welke ouder het gaat volgens de BRP
    * `ouder1` - 1
    * `ouder2` - 2

    """

    ouder1 = "ouder1"
    ouder2 = "ouder2"


class RedenOpschortingBijhoudingEnum(Enum):
    """
        Redenen voor opschorting van de bijhouding
    * `overlijden` - O
    * `emigratie` - E
    * `ministerieel_besluit` - M
    * `pl_aangelegd_in_de_rni` - R - opgeschort omdat persoon is ingeschreven in het Register Niet Ingezeten (RNI).
    * `fout` - F

    """

    overlijden = "overlijden"
    emigratie = "emigratie"
    ministerieel_besluit = "ministerieel_besluit"
    pl_aangelegd_in_de_rni = "pl_aangelegd_in_de_rni"
    fout = "fout"


class SoortAdresEnum(Enum):
    """
        Aanduiding van het soort adres
    * `woonadres` - W - adres waar de persoon woont
    * `briefadres` - B - het adres van een andere persoon of van een instelling (de zogenoemde briefadresgever). Met dit adres van de briefadresgever is de persoon zonder woonadres toch bereikbaar voor de overheid.

    """

    woonadres = "woonadres"
    briefadres = "briefadres"


class SoortVerbintenisEnum(Enum):
    """
        Soort verbintenis die bij de burgerlijke stand is ingeschreven
    * `huwelijk` - H
    * `geregistreerd_partnerschap` - P

    """

    huwelijk = "huwelijk"
    geregistreerd_partnerschap = "geregistreerd_partnerschap"


class Foutbericht(BaseModel):
    """
    Terugmelding bij een fout. JSON representatie in lijn met [RFC7807](https://tools.ietf.org/html/rfc7807).
    """

    type: Optional[AnyUrl] = Field(None, description="Link naar meer informatie over deze fout")
    title: Optional[str] = Field(None, description="Beschrijving van de fout")
    status: Optional[int] = Field(None, description="Http status code")
    detail: Optional[str] = Field(None, description="Details over de fout")
    instance: Optional[AnyUrl] = Field(
        None, description="Uri van de aanroep die de fout heeft veroorzaakt"
    )
    code: Optional[constr(min_length=1)] = Field(
        None, description="Systeemcode die het type fout aangeeft"
    )


class InvalidParams(BaseModel):
    """
    Details over fouten in opgegeven parameters
    """

    type: Optional[AnyUrl] = Field(
        None,
        example="https://www.vng.nl/realisatie/api/{major-versie}/validaties/integer",
    )
    name: Optional[str] = Field(
        None,
        description="Naam van de parameter",
        example="verblijfplaats__huisnummer",
    )
    code: Optional[constr(min_length=1)] = Field(
        None,
        description="Systeemcode die het type fout aangeeft",
        example="integer",
    )
    reason: Optional[str] = Field(
        None,
        description="Beschrijving van de fout op de parameterwaarde",
        example="Waarde is geen geldige integer.",
    )


class DatumOnvolledig(BaseModel):
    """
    Gegevens over de datums die mogelijk niet volledig zijn.
    """

    dag: Optional[conint(ge=1, le=31)] = Field(
        None,
        description=(
            "Als de dag van de datum bekend is wordt dit element gevuld, ook"
            " als de volledige datum bekend is."
        ),
        example=3,
    )
    datum: Optional[date] = Field(
        None,
        description=(
            "Als de volledige datum bekend is wordt de datum gevuld die in de"
            " date definitie past."
        ),
        example="1989-05-03",
    )
    jaar: Optional[conint(le=9999)] = Field(
        None,
        description=(
            "Als het jaar van de datum bekend is wordt dit element gevuld, ook"
            " als de volledige datum bekend is."
        ),
        example=1989,
    )
    maand: Optional[conint(ge=1, le=12)] = Field(
        None,
        description=(
            "Als de maand van een datum bekend is wordt dit element gevuld,"
            " ook als de volledige datum bekend is."
        ),
        example=5,
    )


class Href(BaseModel):
    __root__: str = Field(
        ...,
        example="https://datapunt.voorbeeldgemeente.nl/api/v{major-versie}/resourcename/{resource-identificatie}",
    )


class Waardetabel(BaseModel):
    code: Optional[str] = Field(None, example="6030")
    omschrijving: Optional[str] = Field(None, example="Nederland")


class Adres(BaseModel):
    """
    Eigenschappen van het adres die kunnen worden hergebruikt in andere API's waarin adresgegevens worden opgenomen.
    """

    straat: Optional[str] = Field(
        None,
        description=("Een naam die door de gemeente aan een openbare ruimte is gegeven."),
        example="Laan van de landinrichtingscommissie Duiven-Westervoort",
        title="openbareruimte naam",
    )
    huisnummer: Optional[int] = Field(
        None,
        description=(
            "Een nummer dat door de gemeente aan een adresseerbaar object is" " gegeven."
        ),
        example=1,
    )
    huisletter: Optional[str] = Field(
        None,
        description=(
            "Een toevoeging aan een huisnummer in de vorm van een letter die"
            " door de gemeente aan een adresseerbaar object is gegeven."
        ),
        example="A",
    )
    huisnummertoevoeging: Optional[str] = Field(
        None,
        description=(
            "Een toevoeging aan een huisnummer of een combinatie van"
            " huisnummer en huisletter die door de gemeente aan een"
            " adresseerbaar object is gegeven."
        ),
        example="bis",
    )
    postcode: Optional[str] = Field(
        None,
        description=(
            "De door PostNL vastgestelde code die bij een bepaalde combinatie"
            " van een straatnaam en een huisnummer hoort."
        ),
        example="6922KZ",
    )
    woonplaats: Optional[str] = Field(
        None,
        description=(
            "Een woonplaats is een gedeelte van het grondgebied van de" " gemeente met een naam."
        ),
        example="Duiven",
        title="woonplaats naam",
    )


class NaamBasis(BaseModel):
    geslachtsnaam: Optional[str] = Field(
        None, description="De achternaam van een persoon.\n", example="Vries"
    )
    voorletters: Optional[str] = Field(
        None,
        description=("De voorletters van de persoon, afgeleid van de voornamen.\n"),
        example="P.J.",
    )
    voornamen: Optional[str] = Field(
        None,
        description=("De verzameling namen voor de geslachtsnaam, gescheiden door" " spaties.\n"),
        example="Pieter Jan",
    )
    voorvoegsel: Optional[str] = Field(None, example="de")
    adellijkeTitelPredikaat: Optional[Waardetabel] = None


class NaamInOnderzoek(BaseModel):
    """
    Geeft aan welke gegevens over de naam in onderzoek zijn. Zie de [functionele specificaties](https://github.com/VNG-Realisatie/Haal-Centraal-BRP-bevragen/blob/v1.1.0/features/in_onderzoek.feature)

    """

    geslachtsnaam: Optional[bool] = None
    voornamen: Optional[bool] = None
    voorvoegsel: Optional[bool] = None
    adellijkeTitelPredikaat: Optional[bool] = None
    datumIngangOnderzoek: Optional[DatumOnvolledig] = None


class NaamPersoonInOnderzoek(NaamInOnderzoek):
    aanduidingNaamgebruik: Optional[bool] = None


class OuderInOnderzoek(BaseModel):
    """
    Geeft aan welke gegevens van de de ouder in onderzoek zijn. Zie de [functionele specificaties](https://github.com/VNG-Realisatie/Haal-Centraal-BRP-bevragen/blob/v1.1.0/features/in_onderzoek.feature)

    """

    burgerservicenummer: Optional[bool] = None
    datumIngangFamilierechtelijkeBetrekking: Optional[bool] = None
    geslachtsaanduiding: Optional[bool] = None
    datumIngangOnderzoek: Optional[DatumOnvolledig] = None


class GeboorteInOnderzoek(BaseModel):
    """
    Geeft aan welke gegevens over de geboorte van de persoon in onderzoek zijn. Zie de [functionele specificaties](https://github.com/VNG-Realisatie/Haal-Centraal-BRP-bevragen/blob/v1.1.0/features/in_onderzoek.feature)

    """

    datum: Optional[bool] = None
    land: Optional[bool] = None
    plaats: Optional[bool] = None
    datumIngangOnderzoek: Optional[DatumOnvolledig] = None


class Kiesrecht(BaseModel):
    europeesKiesrecht: Optional[bool] = Field(
        None,
        description=(
            "Geeft aan of persoon een oproep moet ontvangen voor verkiezingen"
            " voor het Europees parlement.\n"
        ),
        example=True,
    )
    uitgeslotenVanKiesrecht: Optional[bool] = Field(None, example=True)
    einddatumUitsluitingEuropeesKiesrecht: Optional[DatumOnvolledig] = None
    einddatumUitsluitingKiesrecht: Optional[DatumOnvolledig] = None


class NaamPersoon(NaamBasis):
    aanhef: Optional[str] = Field(
        None,
        description=("Kun je gebruiken als aanhef in een brief gericht aan persoon.\n"),
        example="Hoogwelgeboren heer",
    )
    aanschrijfwijze: Optional[str] = Field(
        None,
        description=(
            "Samengestelde naam die je kunt gebruiken in de communicatie met" " de persoon.\n"
        ),
        example="H.W. baron van den Aedel",
    )
    regelVoorafgaandAanAanschrijfwijze: Optional[str] = Field(
        None,
        description=(
            "Deze regel moet als aparte regel boven de aanschrijfwijze worden"
            " geplaatst. Komt alleen voor bij personen met een adellijke titel"
            " of predicaat.\n"
        ),
        example="De hoogwelgeboren heer",
    )
    gebruikInLopendeTekst: Optional[str] = Field(
        None,
        description=(
            "Naam van persoon die je kunt gebruiken als je in lopende tekst"
            " (bijvoorbeeld in een brief) aan persoon refereert.\n"
        ),
        example="baron Van den Aedel",
    )
    aanduidingNaamgebruik: Optional[NaamgebruikEnum] = None
    inOnderzoek: Optional[NaamPersoonInOnderzoek] = None


class PersoonInOnderzoek(BaseModel):
    """
    Geeft aan welke gegevens van de persoon in onderzoek zijn. Zie de [functionele specificaties](https://github.com/VNG-Realisatie/Haal-Centraal-BRP-bevragen/blob/v1.1.0/features/in_onderzoek.feature).

    """

    burgerservicenummer: Optional[bool] = None
    geslachtsaanduiding: Optional[bool] = None
    datumIngangOnderzoek: Optional[DatumOnvolledig] = None


class NationaliteitInOnderzoek(BaseModel):
    """
    Geeft aan welke gegevens over de nationaliteit in onderzoek zijn. Zie de [functionele specificaties](https://github.com/VNG-Realisatie/Haal-Centraal-BRP-bevragen/blob/v1.1.0/features/in_onderzoek.feature)

    """

    aanduidingBijzonderNederlanderschap: Optional[bool] = None
    nationaliteit: Optional[bool] = None
    redenOpname: Optional[bool] = None
    datumIngangOnderzoek: Optional[DatumOnvolledig] = None


class OpschortingBijhouding(BaseModel):
    """
    * **datum**: de datum waarop de bijhouding van de persoonsgegevens is gestaakt.

    """

    reden: Optional[RedenOpschortingBijhoudingEnum] = None
    datum: Optional[DatumOnvolledig] = None


class OverlijdenInOnderzoek(GeboorteInOnderzoek):
    """
    Geeft aan welke gegevens over het overlijden van de persoon in onderzoek zijn. Zie de [functionele specificaties](https://github.com/VNG-Realisatie/Haal-Centraal-BRP-bevragen/blob/v1.1.0/features/in_onderzoek.feature)

    """

    pass


class KindInOnderzoek(BaseModel):
    """
    Geeft aan of de gegevens over het kind van de persoon in onderzoek zijn. Zie de [functionele specificaties](https://github.com/VNG-Realisatie/Haal-Centraal-BRP-bevragen/blob/v1.1.0/features/in_onderzoek.feature)

    """

    burgerservicenummer: Optional[bool] = None
    datumIngangOnderzoek: Optional[DatumOnvolledig] = None


class PartnerInOnderzoek(BaseModel):
    """
    Geeft aan welke gegevens over het huwelijk of het partnerschap in onderzoek zijn. Zie de [functionele specificaties](https://github.com/VNG-Realisatie/Haal-Centraal-BRP-bevragen/blob/v1.1.0/features/in_onderzoek.feature)

    """

    burgerservicenummer: Optional[bool] = None
    geslachtsaanduiding: Optional[bool] = None
    soortVerbintenis: Optional[bool] = None
    datumIngangOnderzoek: Optional[DatumOnvolledig] = None


class AangaanHuwelijkPartnerschapInOnderzoek(GeboorteInOnderzoek):
    """
    Geeft aan welke gegevens over het voltrekken van het huwelijk of aangaan van het partnerschap in onderzoek zijn. Zie de functionele specificaties. Zie de [functionele specificaties](https://github.com/VNG-Realisatie/Haal-Centraal-BRP-bevragen/blob/v1.1.0/features/in_onderzoek.feature)

    """

    pass


class VerblijfplaatsInOnderzoek(BaseModel):
    """
    Geeft aan welke gegevens over het verblijf en adres van de persoon in onderzoek zijn. Elementen van het GBA-adres zelf (Dat zou eigenlijk een BAG-adres moeten zijn) kunnen niet in onderzoek zijn. Wel de relatie naar de nummeraanduiding. Dat wordt gedaan door de identificatiecodeNummeraanduiding in onderzoek te zetten. Zie de [functionele specificaties](https://github.com/VNG-Realisatie/Haal-Centraal-BRP-bevragen/blob/v1.1.0/features/in_onderzoek.feature)

    """

    aanduidingBijHuisnummer: Optional[bool] = None
    datumAanvangAdreshouding: Optional[bool] = None
    datumIngangGeldigheid: Optional[bool] = None
    datumInschrijvingInGemeente: Optional[bool] = None
    datumVestigingInNederland: Optional[bool] = None
    functieAdres: Optional[bool] = None
    gemeenteVanInschrijving: Optional[bool] = None
    huisletter: Optional[bool] = None
    huisnummer: Optional[bool] = None
    huisnummertoevoeging: Optional[bool] = None
    nummeraanduidingIdentificatie: Optional[bool] = None
    adresseerbaarObjectIdentificatie: Optional[bool] = None
    landVanwaarIngeschreven: Optional[bool] = None
    locatiebeschrijving: Optional[bool] = None
    straat: Optional[bool] = None
    postcode: Optional[bool] = None
    korteNaam: Optional[bool] = None
    verblijfBuitenland: Optional[bool] = None
    woonplaats: Optional[bool] = None
    datumIngangOnderzoek: Optional[DatumOnvolledig] = None


class GezagsverhoudingInOnderzoek(BaseModel):
    """
    Geeft aan welke gegevens van de gezagsverhouding in onderzoek zijn. Zie de [functionele specificaties](https://github.com/VNG-Realisatie/Haal-Centraal-BRP-bevragen/blob/v1.1.0/features/in_onderzoek.feature)

    """

    indicatieCurateleRegister: Optional[bool] = None
    indicatieGezagMinderjarige: Optional[bool] = None
    datumIngangOnderzoek: Optional[DatumOnvolledig] = None


class VerblijfstitelInOnderzoek(BaseModel):
    """
    Geeft aan welke gegevens over de verblijfstitel in onderzoek zijn. Zie de [functionele specificaties](https://github.com/VNG-Realisatie/Haal-Centraal-BRP-bevragen/blob/v1.1.0/features/in_onderzoek.feature)

    """

    aanduiding: Optional[bool] = None
    datumEinde: Optional[bool] = None
    datumIngang: Optional[bool] = None
    datumIngangOnderzoek: Optional[DatumOnvolledig] = None


class Geboortedatum(BaseModel):
    """
        Gegevens over de geboorte van respectievelijk de persoon, de ouder, de echtgenoot/geregistreerd partner, de eerdere echtgenoot/geregistreerd partner of het kind.
    * **datum** : Datum waarop de persoon is geboren
    * **land** : Land waar de persoon is geboren
    * **plaats** : De plaats waar de persoon is geboren. Voor een plaats buiten Nederland is gemeentecode=1999 (RNI) en gemeentenaam de buitenlandse plaatsnaam of aanduiding.

    """

    datum: Optional[DatumOnvolledig] = None


class BadRequestFoutbericht(Foutbericht):
    invalidParams: Optional[List[InvalidParams]] = Field(
        None,
        description=(
            "Foutmelding per fout in een parameter. Alle gevonden fouten"
            " worden één keer teruggemeld."
        ),
    )


class HalLink(BaseModel):
    """
    De Link Object zoals gespecificeerd in https://tools.ietf.org/html/draft-kelly-json-hal-08#section-5; Deze link kan als templated link worden aangeboden. [URI-templating is hier beschreven](https://github.com/VNG-Realisatie/Haal-Centraal-common/blob/v1.2.0/features/uri-templating.feature).
    """

    href: Href
    templated: Optional[bool] = None
    title: Optional[str] = Field(None, description="Voor mens leesbaar label bij de link")


class Naam(NaamBasis):
    inOnderzoek: Optional[NaamInOnderzoek] = None


class Geboorte(Geboortedatum):
    land: Optional[Waardetabel] = None
    plaats: Optional[Waardetabel] = None
    inOnderzoek: Optional[GeboorteInOnderzoek] = None


class Nationaliteit(BaseModel):
    """
    * **redenOpname** : De reden op grond waarvan de persoon de nationaliteit gekregen heeft.

    """

    aanduidingBijzonderNederlanderschap: Optional[AanduidingBijzonderNederlanderschapEnum] = None
    datumIngangGeldigheid: Optional[DatumOnvolledig] = None
    nationaliteit: Optional[Waardetabel] = None
    redenOpname: Optional[Waardetabel] = None
    inOnderzoek: Optional[NationaliteitInOnderzoek] = None


class Overlijden(BaseModel):
    """
        Gegevens over het overlijden van de persoon.
    * **datum** : datum waarop de persoon is overleden.
    * **land** : land waar de persoon is overleden.
    * **plaats** : gemeente waar de persoon is overleden. Is de persoon overleden buiten Nederland, dan bevat het antwoord alleen een buitenlandse plaatsnaam of aanduiding.

    """

    indicatieOverleden: Optional[bool] = Field(
        None,
        description=(
            "Geeft aan dat iemand is overleden (waarde true), ongeacht of de"
            " overlijdensdatum bekend is.\n"
        ),
    )
    datum: Optional[DatumOnvolledig] = None
    land: Optional[Waardetabel] = None
    plaats: Optional[Waardetabel] = None
    inOnderzoek: Optional[OverlijdenInOnderzoek] = None


class AangaanHuwelijkPartnerschap(BaseModel):
    """
        Gegevens over de voltrekking van het huwelijk of het aangaan van het geregistreerd partnerschap.
    * **datum** : De datum waarop het huwelijk is voltrokken of het partnerschap is aangegaan.
    * **land** : Het land waar het huwelijk is voltrokken of het partnerschap is aangegaan.
    * **plaats** : De gemeente waar het huwelijk is voltrokken of het partnerschap is aangegaan. Voor een plaats buiten Nederland bevat het antwoord een buitenlandse plaatsnaam of aanduiding.

    """

    datum: Optional[DatumOnvolledig] = None
    land: Optional[Waardetabel] = None
    plaats: Optional[Waardetabel] = None
    inOnderzoek: Optional[AangaanHuwelijkPartnerschapInOnderzoek] = None


class Verblijfplaats(Adres):
    adresseerbaarObjectIdentificatie: Optional[str] = Field(
        None,
        description=(
            "De verblijfplaats van de persoon kan een ligplaats, een"
            " standplaats of een verblijfsobject zijn.\n"
        ),
        example="0226010000038820",
    )
    aanduidingBijHuisnummer: Optional[AanduidingBijHuisnummerEnum] = None
    nummeraanduidingIdentificatie: Optional[str] = Field(
        None,
        description=(
            "Unieke identificatie van een nummeraanduiding (en het"
            " bijbehorende adres) in de BAG.\n"
        ),
        example="0518200000366054",
    )
    functieAdres: Optional[SoortAdresEnum] = None
    indicatieVestigingVanuitBuitenland: Optional[bool] = Field(
        None,
        description=(
            "Geeft aan dat de ingeschreven persoon zich vanuit het buitenland"
            " heeft ingeschreven.\n"
        ),
    )
    locatiebeschrijving: Optional[str] = Field(
        None,
        description=(
            "Omschrijving van de ligging van een verblijfsobject, standplaats" " of ligplaats.\n"
        ),
        example="Naast de derde brug",
    )
    korteNaam: Optional[str] = Field(
        None,
        description=(
            "De officiële openbareruimtenaam uit de Basisregistratie Gebouwen"
            " en Adressen (BAG) of een verkorte versie.\n"
        ),
    )
    vanuitVertrokkenOnbekendWaarheen: Optional[bool] = Field(
        None,
        description=(
            "Geeft aan dat de persoon is teruggekeerd uit een situatie van"
            " 'vertrokken onbekend waarheen.'\n"
        ),
        example=True,
    )
    datumAanvangAdreshouding: Optional[DatumOnvolledig] = None
    datumIngangGeldigheid: Optional[DatumOnvolledig] = None
    datumInschrijvingInGemeente: Optional[DatumOnvolledig] = None
    datumVestigingInNederland: Optional[DatumOnvolledig] = None
    gemeenteVanInschrijving: Optional[Waardetabel] = None
    landVanwaarIngeschreven: Optional[Waardetabel] = None
    adresregel1: Optional[str] = Field(
        None,
        description=(
            "Het eerste deel van een adres is een combinatie van de straat en" " huisnummer.\n"
        ),
        example=("Laan van de landinrichtingscommissie Duiven-Westervoort 26A-3"),
    )
    adresregel2: Optional[str] = Field(
        None,
        description=(
            "Het tweede deel van een adres is een combinatie van woonplaats"
            " eventueel in combinatie met de postcode.\n"
        ),
        example="1234AA Nootdorp",
    )
    adresregel3: Optional[str] = Field(
        None,
        description=(
            "Het derde deel van een adres is optioneel. Het gaat om een of"
            " meer geografische gebieden van het adres in het buitenland.\n"
        ),
        example="Selangor",
    )
    vertrokkenOnbekendWaarheen: Optional[bool] = Field(
        None,
        description=(
            "Indicatie dat de ingeschreven persoon is vertrokken naar het"
            " buitenland, maar dat niet bekend is waar naar toe.\n"
        ),
    )
    land: Optional[Waardetabel] = None
    inOnderzoek: Optional[VerblijfplaatsInOnderzoek] = None


class Gezagsverhouding(BaseModel):
    """
    Gegevens over het gezag over de persoon.

    """

    indicatieCurateleRegister: Optional[bool] = Field(
        None,
        description="Geeft aan dat de persoon onder curatele is gesteld.\n",
        example=True,
    )
    indicatieGezagMinderjarige: Optional[IndicatieGezagMinderjarigeEnum] = None
    inOnderzoek: Optional[GezagsverhoudingInOnderzoek] = None


class Verblijfstitel(BaseModel):
    """
        Gegevens over de verblijfsrechtelijke status van de persoon.
    * **datumEinde**: Datum waarop de geldigheid van de gegevens over de verblijfstitel is beëindigd.
    * **datumIngang**: Datum waarop de gegevens over de verblijfstitel geldig zijn geworden.
    * **aanduiding** : Verblijfstiteltabel die aangeeft over welke verblijfsrechtelijke status de persoon beschikt.

    """

    aanduiding: Optional[Waardetabel] = None
    datumEinde: Optional[DatumOnvolledig] = None
    datumIngang: Optional[DatumOnvolledig] = None
    inOnderzoek: Optional[VerblijfstitelInOnderzoek] = None


class IngeschrevenPersoonLinks(BaseModel):
    self: Optional[HalLink] = None
    ouders: Optional[List[HalLink]] = Field(None, description="De ouders van de persoon.\n")
    reisdocumenten: Optional[List[HalLink]] = Field(
        None,
        description="De reisdocumenten die aan de persoon zijn verstrekt.\n",
    )
    kinderen: Optional[List[HalLink]] = Field(None, description="De kinderen van de persoon.\n")
    partners: Optional[List[HalLink]] = Field(
        None,
        description=(
            "De actuele bij de ingeschreven persoon geregistreerde huwelijken"
            " en geregistreerd partnerschappen. Een beëindigd huwelijk of"
            " geregistreerd partnerschap wordt niet teruggegeven.\n"
        ),
    )
    partnerhistorie: Optional[HalLink] = None
    verblijfplaatshistorie: Optional[HalLink] = None
    verblijfstitelhistorie: Optional[HalLink] = None
    nationaliteitHistorie: Optional[HalLink] = None
    adres: Optional[HalLink] = None


class OuderLinks(BaseModel):
    self: Optional[HalLink] = None
    ingeschrevenPersoon: Optional[HalLink] = None


class KindLinks(OuderLinks):
    pass


class PartnerLinks(OuderLinks):
    pass


class HalCollectionLinks(BaseModel):
    """
    HalCollectionLinks bevat de self link die elke HAL Resource minimaal moet hebben in zijn _links property

    """

    self: Optional[HalLink] = None


class Ouder(BaseModel):
    """
        Gegevens over de ouder van de persoon.
    * **datumIngangFamilierechtelijkeBetrekking** - De datum waarop de familierechtelijke betrekking is ontstaan.

    """

    burgerservicenummer: Optional[str] = Field(None, example="555555021")
    geslachtsaanduiding: Optional[GeslachtEnum] = None
    ouderAanduiding: Optional[OuderAanduidingEnum] = None
    datumIngangFamilierechtelijkeBetrekking: Optional[DatumOnvolledig] = None
    naam: Optional[Naam] = None
    inOnderzoek: Optional[OuderInOnderzoek] = None
    geboorte: Optional[Geboorte] = None


class OuderHalBasis(Ouder):
    geheimhoudingPersoonsgegevens: Optional[bool] = Field(
        None,
        description=(
            "Gegevens mogen niet worden verstrekt aan derden /" " maarschappelijke instellingen.\n"
        ),
        title="Indicatie geheim",
    )
    _links: Optional[OuderLinks] = None


class Kind(BaseModel):
    """
    Gegevens over een kind van de persoon.

    """

    burgerservicenummer: Optional[str] = Field(None, example="555555021")
    leeftijd: Optional[int] = Field(
        None, description="Leeftijd op het moment van bevragen\n", example=12
    )
    inOnderzoek: Optional[KindInOnderzoek] = None
    naam: Optional[Naam] = None
    geboorte: Optional[Geboorte] = None


class KindHalBasis(Kind):
    geheimhoudingPersoonsgegevens: Optional[bool] = Field(
        None,
        description=(
            "Gegevens mogen niet worden verstrekt aan derden/ maatschappelijke" " instellingen.\n"
        ),
        title="Indicatie geheim",
    )
    _links: Optional[KindLinks] = None


class Partner(BaseModel):
    """
    Gegevens over een gesloten huwelijk/geregistreerd partnerschap van de persoon.

    """

    burgerservicenummer: Optional[str] = Field(None, example="555555021")
    geslachtsaanduiding: Optional[GeslachtEnum] = None
    soortVerbintenis: Optional[SoortVerbintenisEnum] = None
    naam: Optional[Naam] = None
    geboorte: Optional[Geboorte] = None
    inOnderzoek: Optional[PartnerInOnderzoek] = None
    aangaanHuwelijkPartnerschap: Optional[AangaanHuwelijkPartnerschap] = None


class PartnerHalBasis(Partner):
    geheimhoudingPersoonsgegevens: Optional[bool] = Field(
        None,
        description=(
            "Gegevens mogen niet worden verstrekt aan derden/ maatschappelijke" " instellingen.\n"
        ),
        title="Indicatie geheim",
    )
    _links: Optional[PartnerLinks] = None


class IngeschrevenPersoonEmbedded(BaseModel):
    ouders: Optional[List[OuderHalBasis]] = Field(None, description="De ouders van de persoon.\n")
    kinderen: Optional[List[KindHalBasis]] = Field(
        None, description="De kinderen van de persoon.\n"
    )
    partners: Optional[List[PartnerHalBasis]] = Field(
        None,
        description=(
            "De partners van de persoon. Een beëindigd huwelijk of"
            " geregistreerd partnerschap wordt niet teruggegeven.\n"
        ),
    )


class IngeschrevenPersoon(BaseModel):
    burgerservicenummer: Optional[str] = Field(None, example="555555021")
    aNummer: Optional[str] = Field(None, description="Het A-nummer van de persoon\n")
    geheimhoudingPersoonsgegevens: Optional[bool] = Field(
        None,
        description=(
            "Gegevens mogen niet worden verstrekt aan derden /" " maatschappelijke instellingen.\n"
        ),
        title="Indicatie geheim",
    )
    geslachtsaanduiding: Optional[GeslachtEnum] = None
    leeftijd: Optional[int] = Field(
        None,
        description="Leeftijd in jaren op het moment van bevragen.\n",
        example=34,
    )
    datumEersteInschrijvingGBA: Optional[DatumOnvolledig] = None
    kiesrecht: Optional[Kiesrecht] = None
    naam: Optional[NaamPersoon] = None
    inOnderzoek: Optional[PersoonInOnderzoek] = None
    nationaliteiten: Optional[List[Nationaliteit]] = None
    geboorte: Optional[Geboorte] = None
    opschortingBijhouding: Optional[OpschortingBijhouding] = None
    overlijden: Optional[Overlijden] = None
    verblijfplaats: Optional[Verblijfplaats] = None
    gezagsverhouding: Optional[Gezagsverhouding] = None
    verblijfstitel: Optional[Verblijfstitel] = None
    reisdocumentnummers: Optional[List[Reisdocumentnummer]] = None
    kinderen: Optional[List[Kind]] = None
    ouders: Optional[List[Ouder]] = None
    partners: Optional[List[Partner]] = None


class IngeschrevenPersoonHalBasis(IngeschrevenPersoon):
    _links: Optional[IngeschrevenPersoonLinks] = None


class IngeschrevenPersoonHal(IngeschrevenPersoonHalBasis):
    _embedded: Optional[IngeschrevenPersoonEmbedded] = None


class OuderHalCollectieEmbedded(BaseModel):
    ouders: Optional[List[OuderHalBasis]] = None


class KindHalCollectieEmbedded(BaseModel):
    kinderen: Optional[List[KindHalBasis]] = None


class PartnerHalCollectieEmbedded(BaseModel):
    partners: Optional[List[PartnerHalBasis]] = None


class IngeschrevenPersoonHalCollectieEmbedded(BaseModel):
    ingeschrevenpersonen: Optional[List[IngeschrevenPersoonHal]] = None


class OuderHalCollectie(BaseModel):
    _links: Optional[HalCollectionLinks] = None
    _embedded: Optional[OuderHalCollectieEmbedded] = None


class KindHalCollectie(BaseModel):
    _links: Optional[HalCollectionLinks] = None
    _embedded: Optional[KindHalCollectieEmbedded] = None


class PartnerHalCollectie(BaseModel):
    _links: Optional[HalCollectionLinks] = None
    _embedded: Optional[PartnerHalCollectieEmbedded] = None


class IngeschrevenPersoonHalCollectie(BaseModel):
    _links: Optional[HalCollectionLinks] = None
    _embedded: Optional[IngeschrevenPersoonHalCollectieEmbedded] = None
